#!/usr/bin/env node
import{Command as d}from"commander";import t from"chalk";import{execSync as c}from"child_process";import b from"prompts";import{detect as g}from"@antfu/ni";async function p(n){let e=await g({programmatic:!0,cwd:n});return e==="yarn@berry"?"yarn":e==="pnpm@6"?"pnpm":e==="bun"?"bun":e??"npm"}import{rm as f}from"fs/promises";var o={name:"@abstract-foundation/create-abstract-app",version:"0.0.1-beta-2",description:"Create a new Abstract app.",publishConfig:{access:"public"},license:"MIT",repository:{type:"git",url:"https://github.com/abstract-foundation/create-abstract-app-cli"},files:["dist"],keywords:["abstract"],type:"module",exports:"./dist/index.js",bin:"./dist/index.js",scripts:{dev:"tsup --watch",build:"tsup",typecheck:"tsc --noEmit",start:"node dist/index.js","format:write":'prettier --write "**/*.{ts,tsx,mdx}" --cache',"format:check":'prettier --check "**/*.{ts,tsx,mdx}" --cache',release:"changeset version","pub:beta":"pnpm build && pnpm publish --no-git-checks --access public --tag beta","pub:next":"pnpm build && pnpm publish --no-git-checks --access public --tag next","pub:release":"pnpm build && pnpm publish --access public",test:"vitest run"},dependencies:{"@antfu/ni":"^0.21.4","@babel/core":"^7.22.1","@babel/parser":"^7.22.6","@babel/plugin-transform-typescript":"^7.22.5",chalk:"5.2.0",commander:"^10.0.0",cosmiconfig:"^8.1.3",diff:"^5.1.0",execa:"^7.0.0","fast-glob":"^3.3.2","fs-extra":"^11.1.0","https-proxy-agent":"^6.2.0","lodash.template":"^4.5.0","node-fetch":"^3.3.0",ora:"^6.1.2",prompts:"^2.4.2",recast:"^0.23.2","ts-morph":"^18.0.0","tsconfig-paths":"^4.2.0",zod:"^3.20.2"},devDependencies:{"@types/babel__core":"^7.20.1","@types/diff":"^5.0.3","@types/fs-extra":"^11.0.1","@types/lodash.template":"^4.5.1","@types/prompts":"^2.4.2",prettier:"^3.3.3",rimraf:"^4.1.3",tsup:"^6.6.3","type-fest":"^3.8.0",typescript:"^4.9.3"},packageManager:"pnpm@9.4.0"};process.on("SIGINT",()=>process.exit(0));process.on("SIGTERM",()=>process.exit(0));async function h(){console.log(t.green(`
       ===+   +===      
       ====   ====      
        ===  ====               _    _         _                  _   
        +=== ====              / \\  | |__  ___| |_ _ __ __ _  ___| |_ 
        ===   ===             / _ \\ | '_ \\/ __| __| '__/ _\` |/ __| __|
 +========     ========+     / ___ \\| |_) \\__ \\ |_| | | (_| | (__| |_ 
 ========       ========    /_/   \\_\\_.__/|___/\\__|_|  \\__,_|\\___|\\__|
 ====   =========   ====   
      ====== ======     
    ======     ======   
    ====         ====    `)),new d().name("create-abstract-app").description("Create a new application with Abstract setup").version(o.version,"-v, --version","display the version number").argument("[project-name]","Name of the project").option("-p, --package-manager <manager>","Package manager to use (npm, yarn, or pnpm)","npm").action(async(e,r)=>{if(!e||e.trim()===""){let s=await b({type:"text",name:"projectName",message:"What is the name of your project?",validate:_=>_.trim()===""?"Project name is required":!0});s.projectName?e=s.projectName:(console.log(t.red("Project creation cancelled.")),process.exit(1))}let i="https://github.com/Abstract-Foundation/create-abstract-app-template";console.log(t.blue(`Creating a new Abstract app in ${e}...`)),c(`git clone ${i} ${e}`,{stdio:"inherit"}),process.chdir(e),await f(".git",{recursive:!0});let m=await p(process.cwd()),a=r.packageManager||m,l=a==="yarn"?"yarn":a==="pnpm"?"pnpm install":a==="bun"?"bun install":"npm install";console.log(t.blue(`Installing dependencies using ${a}...`)),c(l,{stdio:"inherit"}),console.log(t.green(`
Success! Your app is ready.`)),console.log(t.yellow(`
To get started, run the following commands:`)),console.log(t.cyan(`
cd ${e}`)),console.log(t.cyan(`${r.packageManager} run dev`))}).parse()}h();
//# sourceMappingURL=index.js.map